[Setup]
AppName=RegBackup
AppVerName=Registry Backup
CreateAppDir=false

[Registry]
;   RegBackup,         ( deletevalue  uninsdeletekey),     ,     .
Root: HKCU; SubKey: Control Panel\Desktop; ValueType: none; ValueName: Wallpaper; Flags: deletevalue uninsdeletevalue; BeforeInstall: RegBackup('HKCU\Control Panel\Desktop')

[Run]
Filename: {uninstallexe}; Flags: nowait postinstall; Description:    ; Parameters: /SILENT
Filename: {cmd}; Parameters: /C del /F /Q /AH IconCache.db; Flags: runhidden nowait; WorkingDir: {code:GetFolderByCSIDL|28}

[Code]
Function GetFolderByCSIDL(CSIDL: String): String; Begin Result:= GetShellFolderByCSIDL(StrToInt(CSIDL), true); End;	//    . : DestDir: {code:GetFolderByCSIDL|28}

function SystemParametersInfo(uAction, uParam: integer; pvParam: longint; fUpdateProfile: integer): boolean; external 'SystemParametersInfoA@user32';

//            
Procedure RegBackup(Path: String); var errCode, n: Integer; RegExe, isKey: String; Keys: TArrayOfString; Begin
  RegExe:= AddBackslash(GetSystemDir) + 'reg.exe'
  if not FileExists(RegExe) then begin MsgBox('Registry backup not created' #13#10 'File reg.exe not found!', mbError, MB_OK); Exit end;
	isKey:= 'HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\{#SetupSetting('AppName')}_regBackup'	{! InnoSetup     AppName_is1}
	if Length(Path) > 0 then
		Exec(RegExe,'copy '+ AddQuotes(Path) +' '+ AddQuotes(AddBackslash(isKey) + Path) +' /s /f','',sw_HIDE, ewWaitUntilTerminated, errCode)
	else begin
		if not RegGetSubkeyNames(HKLM, Copy(isKey, 6,Length(isKey)), Keys) then Exit; {   }
	for n:= 0 to GetArrayLength(Keys) -1 do	{ reg.exe      }
		Exec(RegExe, 'copy '+ AddQuotes(AddBackslash(isKey) + Keys[n]) +' '+ Keys[n] +' /s /f','', sw_HIDE, ewWaitUntilTerminated, errCode)
	RegDeleteKeyIncludingSubkeys(HKLM, Copy(isKey, 6,Length(isKey)))
	end;
End;

Procedure CurStepChanged(CurStep: TSetupStep);
Begin
    if CurStep = ssPostInstall then SystemParametersInfo(20,0,0,2) { update Desktop}
End;

Procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);	Begin
	if CurUninstallStep = usPostUninstall then begin RegBackup(''); SystemParametersInfo(20,0,0,2) end
End;
