#define MyAppName "My Program"
#define MyAppVerName "My Program 1.5"
#define MyAppPublisher "My Company, Inc."
#define MyAppURL "http://www.example.com/"
#define MyAppExeName "MyProg.exe"

[Setup]
AppName={#MyAppName}
AppVerName={#MyAppVerName}
DefaultDirName={pf}\{#MyAppName}
OutputBaseFilename=setup

[Code]
procedure FlipBitmap(Bitmap:TBitmap;FlipHor:boolean);
var
  x,y,W,H:integer;
  mp:TColor;
begin
  W:=Bitmap.Width-1;
  H:=Bitmap.Height-1;
  if FlipHor then
    for y:=0 to H do
      for x:=0 to W div 2 do begin
        mp:=Bitmap.Canvas.Pixels[x,y];
        Bitmap.Canvas.Pixels[x,y]:=Bitmap.Canvas.Pixels[W-x,y];
        Bitmap.Canvas.Pixels[W-x,y]:=mp;
      end
  else
    for y:=0 to H div 2 do
      for x:=0 to W do begin
        mp:=Bitmap.Canvas.Pixels[x,y];
        Bitmap.Canvas.Pixels[x,y]:=Bitmap.Canvas.Pixels[x,H-y];
        Bitmap.Canvas.Pixels[x,H-y]:=mp;
      end;
end;

procedure HorButtonClick(Sender: TObject);
begin
  FlipBitmap(WizardForm.WizardBitmapImage.Bitmap,True);
  WizardForm.WizardBitmapImage.Invalidate;
end;

procedure VertButtonClick(Sender: TObject);
begin
  FlipBitmap(WizardForm.WizardBitmapImage.Bitmap,False);
  WizardForm.WizardBitmapImage.Invalidate;
end;

procedure InitializeWizard;
begin
  with TButton.Create(WizardForm) do begin
    Parent:=WizardForm;
    Caption:=' ';
    Width:=140;
    Height:=20;
    Left:=10;
    Top:=WizardForm.Height-75;
    OnClick:=@HorButtonClick;
  end;
  with TButton.Create(WizardForm) do begin
    Parent:=WizardForm;
    Caption:=' ';
    Width:=140;
    Height:=20;
    Left:=10;
    Top:=WizardForm.Height-55;
    OnClick:=@VertButtonClick;
  end;
end;
