[Setup]
AppName=My Program
AppVerName=My Program version 1.5
DefaultDirName={pf}\My Program

[Files]
Source: ReadMe1.rtf; Flags: dontcopy
Source: ReadMe2.rtf; Flags: dontcopy
Source: ReadMe3.rtf; Flags: dontcopy

[Code]
var
  Page: TWizardPage;
  ListBox: TNewCheckListBox;
  Memo: TRichEditViewer;
  CheckLabel: TLabel;
  MouseY: integer;

procedure CheckOnClick (Sender: TObject);
begin
  if MouseY < ListBox.Items.Count then
    ListBox.Checked[MouseY]:= Not(ListBox.Checked[MouseY]);
end;

procedure CheckMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  MouseY:= Y/ScaleY(16);
  if MouseY < ListBox.Items.Count then
    Memo.RTFText:= TStrings(ListBox.ItemObject[MouseY]).Text;
end;

Procedure InitializeWizard();
begin
  ExtractTemporaryFile('ReadMe1.rtf');
  ExtractTemporaryFile('ReadMe2.rtf');
  ExtractTemporaryFile('ReadMe3.rtf');

  Page:=CreateCustomPage(3, '', ' ,    .')

  ListBox:= TNewCheckListBox.Create(Page);
  with ListBox do
    begin
      Left   := 15
      Top    := 0
      Width  := 200
      Height := 149
      Parent := Page.Surface
      AddCheckBox('aaa', 'ddd', 0, True, True, False, True, TStringList.Create);
      AddCheckBox('bbb', 'eee', 0, True, True, False, True, TStringList.Create);
      AddCheckBox('ccc', 'fff', 0, True, True, False, True, TStringList.Create);

      TStrings(ItemObject[0]).LoadFromFile(ExpandConstant('{tmp}\ReadMe1.rtf'));
      TStrings(ItemObject[1]).LoadFromFile(ExpandConstant('{tmp}\ReadMe2.rtf'));
      TStrings(ItemObject[2]).LoadFromFile(ExpandConstant('{tmp}\ReadMe3.rtf'));
    end;

  Memo:= TRichEditViewer.Create(Page);
  with Memo do
    begin
      Left        := ListBox.Left + ListBox.Width + 8;
      Top         := ListBox.Top;
      Width       := ListBox.Width
      Height      := ListBox.Height
      Color       := clBtnFace
      Enabled     := False
      BorderStyle := bsNone
      Parent      := Page.Surface
    end;

  CheckLabel:= TLabel.Create(Page);
  with CheckLabel do
    begin
      Width       :=ListBox.Width
      Height      :=ListBox.Height
      Autosize    :=False
      Transparent :=True
      OnMouseMove :=@CheckMouseMove
      OnClick     :=@CheckOnClick
      Parent      :=ListBox
    end;
end;