#define MaxSlicesCount 255
#define OneSliceSize 46368582
#define i

[Setup]
AppName=My Program
AppVerName=My Program version 1.5
DefaultDirName={pf}\My Program

[Files]
Source: compiler:Examples\MyProg.exe; DestDir: {app}
Source: compiler:Examples\MyDll.dll; DestDir: {app}
Source: compiler:Examples\MyProg.chm; DestDir: {app}

#sub AddFile
Source: {code:GetFileName|{#i}}; DestDir: {app}; Check: NeedSlice({#i}); BeforeInstall: SearchSlice({#i}); ExternalSize: {#OneSliceSize}; Flags: external
#endsub

#for {i = 1; i <= MaxSlicesCount; i++} AddFile

[Code]
var
  MaxSlice, CurrentSlice: integer;

function GetFileName(Param: string): string;
begin
  Result:= ExpandConstant('{src}\') +
           Format('DATA.%.3d', [StrToInt(Param)]);
end;

function NeedSlice(current: integer): Boolean;
begin
  if current <=  MaxSlice then  Result:= True;
end;

procedure SearchSlice(Param: integer);
var
  FileName: string;
  FileFound: boolean;
begin
  FileName:= GetFileName(IntToStr(Param));
  FileFound:= FileExists(FileName);
  while not FileFound do
    begin
      if MsgBox('  ' + IntToStr(Param) +
              '      ',
              mbInformation, MB_RETRYCANCEL) = IDRETRY then
        FileFound:= FileExists(FileName)
      else
        if ExitSetupMsgBox then
          begin
            WizardForm.CancelButton.OnClick(WizardForm.CancelButton);
            Break;
          end;
    end;
end;

function GetMaxSlice(): integer;
var
  FS: TFileStream;
  str: string;
begin
  str:= StringOfChar(' ', 1);
  FS := TFileStream.Create(ExpandConstant('{src}\setup.exe'), fmOpenRead);
  try
    FS.Seek(8,soFromBeginning);
    FS.ReadBuffer(str, 1);
    Result:=Ord(str[1]);
  finally
    FS.Free;
  end;
end;

procedure InitializeWizard();
begin
  MaxSlice:= GetMaxSlice();
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
begin
  if CurPageID = wpInstalling then
    Confirm:= False;
end;
