[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DirExistsWarning=no
DefaultDirName={pf}\My Program

[Files]
Source: {code:SrcDir}\*; DestDir: {app}; Flags: external

[Code]
var
  Page: TInputDirWizardPage;
  DataDir: String;

function SrcDir(Param: String): String;
begin
  Result := DataDir;
end;

procedure InitializeWizard();
begin
  Page := CreateInputDirPage(wpUserInfo,
  'Select Data Location', 'Where should data files be stored?',
  'Data files will be stored in the following folder.'#13#10#13#10 +
  'To continue, click Next. If you would like to select a different folder, click Browse.',
  False, '');
  Page.Add('');
  Page.Values[0] := ExpandConstant('{userappdata}\My Company\My Program');
end;

function NextButtonClick(CurPageID: Integer): Boolean;
begin
  Result:= True;
  if CurPageID = Page.ID then
    if Not DirExists(Page.Values[0]) then
      Result:= False
    else
      DataDir := Page.Values[0];
end;