[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DefaultDirName={pf}\My Program

[Files]
;Source: Files\*; DestDir: {app}

[Code]
var
  Form: TSetupForm;
  ListBox: TListBox;
  CancelButton, DelButton: TButton;

procedure FillListBox(const fromDir, fileMask: string; Level: Byte);
var
  FSR, DSR: TFindRec;
  FindResult: Boolean;
  APath: string;
  MainLen: integer;
  i: integer;
begin
  MainLen:= Length(ExpandConstant('{app}'));
  APath := AddBackslash(fromDir);
  FindResult := FindFirst(APath + fileMask, FSR);
  try
    while FindResult do
    begin
      if FSR.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then
        begin
  {files} i:= ListBox.Items.Add(Copy(APath + FSR.Name, MainLen+2, Length(APath + FSR.Name)));
        end;
      FindResult := FindNext(FSR);
    end;
    FindResult := FindFirst(APath + '*.*', DSR);
    while FindResult do
    begin
      if ((DSR.Attributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) and
        not ((DSR.Name = '.') or (DSR.Name = '..')) then
          begin
{Recursion} FillListBox(APath + DSR.Name, fileMask, Level+1);
          end;
      FindResult := FindNext(DSR);
    end;
  finally
    FindClose(FSR);
    FindClose(DSR);
  end;
end;

procedure DeleteFiles();
begin
  DelTree(ExpandConstant('{app}'), True, True, True);
end;

procedure BrowseRemainedFiles();
begin
  Form:= CreateCustomForm;
  Form.ClientWidth := ScaleX(500);
  Form.ClientHeight := ScaleY(400);
  Form.Caption := 'Files to delete';
  Form.Center;

  ListBox := TListBox.Create(Form);
  ListBox.Left:= ScaleX(20);
  ListBox.Top:= ScaleY(20);
  ListBox.Width:= Form.ClientWidth - ScaleX(20*2);
  ListBox.Height:= Form.ClientHeight - ScaleY(23*2 + 20);
  ListBox.Parent:= Form;

  CancelButton := TButton.Create(Form);
  CancelButton.Parent := Form;
  CancelButton.Width := ScaleX(75);
  CancelButton.Height := ScaleY(23);
  CancelButton.Left := Form.ClientWidth - CancelButton.Width - ScaleX(20);
  CancelButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  CancelButton.Caption := 'Cancel';
  CancelButton.ModalResult := mrCancel;
  CancelButton.Cancel := True;

  DelButton := TButton.Create(Form);
  DelButton.Parent := Form;
  DelButton.Width := ScaleX(75);
  DelButton.Height := ScaleY(23);
  DelButton.Left := CancelButton.Left - DelButton.Width - ScaleX(10);
  DelButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  DelButton.Caption := 'Delete';
  DelButton.ModalResult := mrOk;

  Form.ActiveControl:= CancelButton;

  FillListBox(ExpandConstant('{app}'), '*', 1);

  if Form.ShowModal() = mrOk then  DeleteFiles();
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
  if DirExists(ExpandConstant('{app}')) and (CurUninstallStep = usPostUninstall) then
    BrowseRemainedFiles();
end;
