; Demonstrates copying 3 files and creating an icon.

[Setup]
AppName=ISSkin Example
AppVerName=ISSkin Example v1.0
AppVersion=1.0.0.2
AppCopyright= 1998-2008 Codejock Software
DefaultDirName={pf}\ISSkin
DefaultGroupName=ISSkin
Compression=lzma/ultra64
SolidCompression=true
WizardImageFile=Office2007.bmp
WizardSmallImageFile=compiler:WizModernSmallImage-IS.bmp
UninstallDisplayIcon={app}\SkinHelper.exe
OutputDir=.
OutputBaseFilename=SetupOffice2007
VersionInfoVersion=1.0.0.2
VersionInfoCompany=Codejock Software
VersionInfoDescription=ISSkin Example Setup
VersionInfoTextVersion=1, 0, 0, 2

[Files]
; Add the ISSkin DLL used for skinning Inno Setup installations.
Source: ISSkin.dll; DestDir: {app}

; Add the Visual Style resource contains resources used for skinning, you can also use Microsoft Visual Styles (*.msstyles) resources.
Source: Office2007.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: Colour.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: Tiger.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: VistaVGUltimate.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: WinXP.Live.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: WinXP.Luna.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: WinXP.Royale.cjstyles; DestDir: {tmp}; Flags: dontcopy
Source: VistaVGBlue.cjstyles; DestDir: {tmp}; Flags: dontcopy

[Icons]
Name: {group}\Uninstall = ISSkin; Filename: {app}\unins000.exe

; The following code block is used to load the ISS, pass in an empty string ('') as the second parameter to LoadSkin to use the Blue color scheme, this is the default color scheme for Office2007.cjstyles.
[Code]
// Importing LoadSkin API from ISSkin.DLL
procedure LoadSkin(lpszPath: String; lpszIniFileName: String); external 'LoadSkin@files:isskin.dll stdcall';
procedure LoadSkinA(lpszPath: String; lpszIniFileName: String); external 'LoadSkin@{tmp}\isskin.dll stdcall delayload uninstallonly';

// Importing UnloadSkin API from ISSkin.DLL
procedure UnloadSkin; external 'UnloadSkin@files:isskin.dll stdcall';

// Importing ShowWindow Windows API from User32.DLL
function ShowWindow(hWnd: Integer; uType: Integer): Integer; external 'ShowWindow@user32.dll stdcall';

function InitializeSetup(): Boolean;
begin
	ExtractTemporaryFile('Office2007.cjstyles');
	ExtractTemporaryFile('Tiger.cjstyles');
	ExtractTemporaryFile('Colour.cjstyles');
	ExtractTemporaryFile('VistaVGUltimate.cjstyles');
	ExtractTemporaryFile('WinXP.Live.cjstyles');
	ExtractTemporaryFile('WinXP.Luna.cjstyles');
	ExtractTemporaryFile('WinXP.Royale.cjstyles');
	ExtractTemporaryFile('VistaVGBlue.cjstyles');
//	LoadSkin(ExpandConstant('{tmp}\Office2007.cjstyles'),'');
//	LoadSkin(ExpandConstant('{tmp}\Tiger.cjstyles'), 'NormalTiger.ini');
//	LoadSkin(ExpandConstant('{tmp}\Colour.cjstyles'), 'NormalAqua.ini');
//	LoadSkin(ExpandConstant('{tmp}\VistaVGUltimate.cjstyles'), 'NormalAero32.ini');
//	LoadSkin(ExpandConstant('{tmp}\WinXP.Live.cjstyles'), 'NormalXPLive.ini');
//	LoadSkin(ExpandConstant('{tmp}\WinXP.Luna.cjstyles'), 'NormalBlue.ini');
//	LoadSkin(ExpandConstant('{tmp}\WinXP.Royale.cjstyles'), 'NormalRoyale.ini');
	LoadSkin(ExpandConstant('{tmp}\VistaVGBlue.cjstyles'), 'NormalAero32.ini');
	Result := True;
end;

//	[VistaVGUltimate.cjstyles]
//	NormalAero32.ini
//	NormalBasic32.ini
//	NormalBlack32.ini
//
//	[Colour.cjstyles]
//	NormalAqua.ini
//	NormalBlue.ini
//	NormalBrown.ini
//	NormalGreen.ini
//	NormalOrange.ini
//	NormalPurple.ini
//	NormalRed.ini
//	NormalYellow.ini
//
//	[Tiger.cjstyles]
//	NormalTiger.ini
//	NormalTigerB.ini
//	NormalTigerG.ini
//
//	[VistaVGBlue.cjstyles]
//	VistaVGBlue.ini
//
//	[WinXP.Live.cjstyles]
//	NormalXPLive.ini
//
//	[WinXP.Luna.cjstyles]
//	NormalBlue.ini
//	NormalMetallic.ini
//	NormalHomestead.ini
//
//	[WinXP.Royale.cjstyles]
//	NormalRoyale.ini

function InitializeUninstall: Boolean;
begin
	FileCopy(ExpandConstant('{app}\isskin.dll'), ExpandConstant('{tmp}\isskin.dll'), False);
	FileCopy(ExpandConstant('{app}\Office2007.cjstyles'), ExpandConstant('{tmp}\Office2007.cjstyles'), False);
	LoadSkinA(ExpandConstant('{tmp}\Office2007.cjstyles'),'');
	Result:= True;
end;

//procedure DeinitializeSetup(); begin
	// Hide Window before unloading skin so user does not get a glimse of an unskinned window before it is closed.
//	ShowWindow(StrToInt(ExpandConstant('{wizardhwnd}')), 0);
//	UnloadSkin();
//end;



