#include "WindowsHook.iss"

#define SrcPath "C:\WINDOWS\Fonts\"
#define Mask "*.*"

#define FindHandle
#define FindResult
#define SearchPath SrcPath + Mask
#define AllFilesSize 0
#define CurFileSize 0

[Setup]
AppName=My Program
AppVerName=My Program version 1.5
DefaultDirName={pf}\My Program

[Files]
Source: compiler:InnoCallback.dll; Flags: dontcopy
#sub ProcessFoundFile
  #define FileName FindGetFileName(FindHandle)
Source: {#SrcPath}{#FileName}; DestDir: {app}; Flags: ignoreversion; BeforeInstall: ProgressInit(); AfterInstall: ProgressReset()
  #expr CurFileSize = FileSize(SrcPath + FileName)
  #expr AllFilesSize = AllFilesSize + CurFileSize
  #expr WriteIni( SourcePath    + "\\SizeInfo.ini","Name", FileName, CurFileSize )
  #expr WriteIni( SourcePath    + "\\SizeInfo.ini","Size", "AllSize", AllFilesSize )
#endsub

#for {FindHandle = FindResult = FindFirst(SearchPath, 0); FindResult; FindResult = FindNext(FindHandle)} ProcessFoundFile

Source: SizeInfo.ini; Flags: dontcopy

[Code]
var
  ProgressBar: TNewProgressBar;
  OldPosition: LongInt;
  ReadyFlag : Boolean;
  KBHookID, WndHookID: LongWord;

function LOWORD(lw: LongWord): LongWord;
begin
  Result:= lw shr 16;
end;

procedure ProgressInit();
begin
  ProgressBar.Min:= 0;
  ProgressBar.Position:= 0;
  OldPosition:= WizardForm.ProgressGauge.Position;

  ProgressBar.Max:= GetIniInt('Name', ExtractFileName(ExpandConstant(CurrentFileName)), 0, 0, 0, ExpandConstant('{tmp}\SizeInfo.ini')) ;

  ReadyFlag:= True;
end;

procedure ProgressReset();
begin
  ReadyFlag:= False;
end;

function ChangePos(var oldpos: LongInt; newpos: LongInt): Longint;
begin
  Result:= newpos - oldpos;
  oldpos:= newpos;
end;

///////////////////   SendMessage //////////////////////////////////
procedure OnWndHook(Code: Integer; wParam: Word; lParam: TCWPSTRUCT);             //
begin                                                                             //
  if Code < 0 then                                                                //
    begin                                                                         //
      CallNextWNDPROC(WndHookID,code,wParam,lparam);                              //
      Exit;                                                                       //
    end;                                                                          //
                                                                                  //
  if (Code = HC_ACTION) and(LOWORD(lParam.msg) = WM_PAINT) and ReadyFlag then     //
    ProgressBar.Position:= ProgressBar.Position +                                 //
                  ChangePos(OldPosition, WizardForm.ProgressGauge.Position );     //
                                                                                  //
  CallNextWNDPROC(WndHookID,code,wParam,lparam);                                  //
end;                                                                              //
//////////////////////    ////////////////////////////////
procedure OnKBHook(Code: Integer; wParam: Word; lParam: LongWord);                //
begin                                                                             //
  if Code < 0 then                                                                //
    begin                                                                         //
      CallNextKBHook(WndHookID,code,wParam,lparam);                               //
      Exit;                                                                       //
    end;                                                                          //
                                                                                  //
  if (Code = HC_ACTION) and                                                       //
     (wParam = Ord('B')) and   //  "B"                                     //
     ((LOWORD(lParam) and KF_UP) <> 0) and   //                           //
     (GetKeyState(VK_SHIFT) < 0) then   //                         //
    MsgBox('You press SHIFT + ''B''', mbInformation, MB_OK);                      //
                                                                                  //
  CallNextKBHook(WndHookID,code,wParam,lparam);                                   //
end;                                                                              //
////////////////////////////////////////////////////////////////////////////////////

procedure InitializeWizard();
begin
  ReadyFlag:= False;
  ExtractTemporaryFile('SizeInfo.ini');
  WndHookID:= SetCALLWNDPROCHook(@OnWndHook); // 1.  SendMessage 
  KBHookID:= SetKBHook(@OnKBHook);  // 2.   

  ProgressBar := TNewProgressBar.Create(WizardForm);
  with WizardForm.ProgressGauge do
    begin
      ProgressBar.Left := Left;
      ProgressBar.Top := Top + ScaleX(30);
      ProgressBar.Width := Width;
      ProgressBar.Height := Height;
      ProgressBar.Parent := WizardForm.InstallingPage;
      ProgressBar.Position := 0;
    end;
end;

procedure DeinitializeSetup();
begin
  HookFree(WndHookID); // 3.  SendMessage 
  HookFree(KBHookID);  // 4.   
end;
