[Setup]
AppName=F.E.A.R. - Extraction Point
AppVerName=F.E.A.R. - Extraction Point v1.0
DefaultDirName={reg:HKLM\Software\FEAR,InstallPath}
DefaultGroupName=FEAR - Extraction Point
OutputDir=D:\F
OutputBaseFilename=setup
Compression=lzma/ultra
SolidCompression=no
DiskSpanning=yes
DiskSliceSize=727000000
AllowNoIcons=yes
UninstallLogMode=overwrite
DisableDirPage=yes
DisableStartupPrompt=yes
DisableReadyPage=yes
UninstallFilesDir={app}\FEARXP
RestartIfNeededByRun=no
UsePreviousAppDir=no
UsePreviousGroup=no
UsePreviousSetupType=no
DisableFinishedPage=yes

[Languages]
Name: "russian"; MessagesFile: "compiler:Languages\Russian.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked

[Components]
Name: "eng"; Description: " ";  Flags: exclusive
Name: "rus"; Description: " ";  Flags: exclusive

[Types]
Name: "custom"; Description: " "; Flags: iscustom

[Files]
Source: "D:\FEARXP\*"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "D:\DIR\*"; DestDir: "{commondocs}\TimeGate Studios"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\BASSMOD.dll"; DestDir: "{tmp}"; Flags: dontcopy
Source: "C:\RELOADED - Act Of War. High Treasonkg.XM"; DestDir: "{tmp}"; Flags: dontcopy
Components: rus; Source: "{src}\Rus\FEARXP_RUS.exe"; DestDir: "{app}\FEARXP"; Flags: ignoreversion external deleteafterinstall

[Icons]
Name: "{group}\  F.E.A.R. - Extraction Point"; Filename: "{app}\FEARXP\FEARXP.exe"; WorkingDir: "{app}\FEARXP"
Name: "{group}\  "; Filename: "{commondocs}\TimeGate Studios"; WorkingDir: "{commondocs}\TimeGate Studios"
Name: "{group}\ F.E.A.R. - Extraction Point"; Filename: "{uninstallexe}"; WorkingDir: "{app}\FEARXP"
Name: "{userdesktop}\F.E.A.R. - Extraction Point"; Filename: "{app}\FEARXP\FEARXP.exe"; Tasks: desktopicon; WorkingDir: "{app}\FEARXP"
Name: "{app}\FEARXP\Shortcut to User directory"; Filename: "{commondocs}\TimeGate Studios"; WorkingDir: "{commondocs}\TimeGate Studios"

[Registry]
Root: HKLM; Subkey: "Software\FEARXP"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\FEARXP"; ValueType: string; ValueName: "InstallPath"; ValueData: "{app}"

[Run]
Filename: "{src}\Redist\WMFADist.exe"; WorkingDir: "{src}\Redist"; Parameters: "/Q"; StatusMsg: " ..."; Flags: waituntilterminated
Filename: "{app}\FEARXP\FEARXP_RUS.exe"; WorkingDir: "{app}\FEARXP"; Parameters: "-y"; Flags: waituntilterminated skipifdoesntexist


[Code]
const
  BASS_MUSIC_RAMP               = 1;      // (  Fast Tracker .xm)
  BASS_MUSIC_RAMPS             = 2;      // (  Fast Tracker .xm)
  BASS_MUSIC_LOOP                = 4;      // 
  BASS_MUSIC_FT2MOD           = 16;     //  .MOD  FastTracker 2
  BASS_MUSIC_PT1MOD           = 32;     //  .MOD  ProTracker 1
  BASS_MUSIC_SURROUND     = 512;    //  surround
  BASS_MUSIC_SURROUND2   = 1024;   //  surround ( 2)

function BASSMOD_Init(device: Integer; freq, flags: DWORD): Boolean;
external 'BASSMOD_Init@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_MusicFree();
external 'BASSMOD_MusicFree@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicLoad(mem: BOOL; f: PChar; offset: DWORD; length: DWORD; flags: DWORD): Boolean;
external 'BASSMOD_MusicLoad@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPlay(): Boolean;
external 'BASSMOD_MusicPlay@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicStop(): Boolean;
external 'BASSMOD_MusicStop@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPause(): Boolean;
external 'BASSMOD_MusicPause@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_Free();
external 'BASSMOD_Free@files:BASSMOD.dll stdcall delayload';

var
  cb:TCheckBox;

procedure PlayOnClick;
var
  Name1: string;
begin
  BASSMOD_MusicFree;
begin
if not BASSMOD_MusicPlay then
 begin
   Name1:=ExpandConstant('{tmp}\RELOADED - Act Of War. High Treasonkg.XM');
 if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_SURROUND or 32 or 1) then
  BASSMOD_MusicPlay;
end;
end;
end;

procedure cdClick(Sender: TObject);
begin
If cb.CHECKED then
PlayOnClick
else
 BASSMOD_MusicStop;
end;


function InitializeSetup(): Boolean;
var
 s, ResultStr:string;
begin
Result:=True;
If not RegKeyExists(HKLM, 'Software\FEAR')
then
begin
 MsgBox('   F.E.A.R.  .' #13#13 '     .', mbError, mb_Ok);
 Result:=False;
 end
 else
   begin
    If RegQueryStringValue(HKLM, 'Software\FEAR', 'InstallPath', ResultStr)
then
  begin
  If ResultStr<>''
then
  begin
   ResultStr:=RemoveQuotes(ResultStr);
  if (FileSearch('FEAR.exe', ResultStr)='')
  or (FileSearch('FEARA_8.Arch00', ResultStr)='')
  or (FileSearch('FEARL_8.Arch00', ResultStr)='')
then
  begin
  s:='   F.E.A.R.  .' #13#13 '     .';
  MsgBox(s, mbError, mb_Ok);
  Result:= False
end
else
  Result:=True;
end;
end;
end;
end;

procedure InitializeWizard();
var
CancelButton: TButton;
begin
  ExtractTemporaryFile(ExpandConstant('BASSMOD.dll'));
  ExtractTemporaryFile(ExpandConstant('RELOADED - Act Of War. High Treasonkg.XM'));
   if not BASSMOD_Init(-1,44100,0)
then
begin
// dll   
  MsgBox('BASSMOD   ,   .', mbError, MB_OK)
  BASSMOD_Free;
end;
WizardForm.Position:=poScreenCenter;
CancelButton := WizardForm.CancelButton;
WizardForm.CancelButton.BringToFront;
  cb:=TCheckBox.Create(WizardForm);
  cb.Parent:=WizardForm;
  cb.Width:=ScaleX(220);
  cb.Left:=ScaleY(10);
  cb.Top:=ScaleY(330);
  cb.CAPTION:=' ';
  cb.ONCLICK:=@cdClick;
  cb.checked:=true;
end;

procedure CurPageChanged(CurPageID: Integer);
begin
if CurPageID=wpInstalling then
 begin
  WizardForm.MainPanel.Visible:=False;
  WizardForm.Bevel1.Visible:=False;
  WizardForm.InnerPage.Color :=clWhite;
  WizardForm.Width:=ScaleX(400);
  WizardForm.Height:=ScaleY(150);
  WizardForm.Left:=ScaleX(5);
  WizardForm.Top:=ScaleY(5);
  WizardForm.InnerNotebook.Left:=ScaleX(10);
  WizardForm.InnerNotebook.Top:=ScaleY(10);
  WizardForm.InnerNotebook.Width:=ScaleX(370);
  WizardForm.StatusLabel.Left:=ScaleX(0);
  WizardForm.StatusLabel.Top:=ScaleY(0);
  WizardForm.StatusLabel.Width:=WizardForm.InnerNotebook.Width;
  WizardForm.FileNameLabel.Left:=ScaleX(0);
  WizardForm.FileNameLabel.Top:=ScaleY(20);
  WizardForm.FileNameLabel.Width:=WizardForm.InnerNotebook.Width;
  WizardForm.ProgressGauge.Top:=ScaleY(40);
  WizardForm.ProgressGauge.Width:=WizardForm.InnerNotebook.Width;
  WizardForm.CancelButton.Left:=ScaleX(154);
  WizardForm.CancelButton.Top:=ScaleY(88);
 end
end;

procedure CurStepChanged(CurStep: TSetupStep);
begin
 If CurStep=ssPostInstall
  then
begin
MsgBox(' !', mbInformation, MB_OK);
end;
end;
