;
; IS 5.1,5
;
; portion of code Michael Winestock
; http://news.jrsoftware.org/news/innosetup/msg53256.html

[Setup]
AppName=Psapi
AppVerName=Psapi
DisableProgramGroupPage=true
DisableStartupPrompt=true
DefaultDirName={pf}\Psapi
InternalCompressLevel=none
Compression=none

[Code]
type
   HANDLE   = LongInt;
   HMODULE  = HANDLE;
   pHMODULE = Array[0..255] of HMODULE;
   LPDWORD  = DWORD;
   PDWORD   = Array[0..255] of DWORD;
   LPTSTR   = String;

const

   PROCESS_QUERY_INFORMATION = $400;
   PROCESS_VM_READ           = $10;
   MAX_LENGTH                = 255;


function OpenProcess(dwDesiredAccess : DWORD; bInheritHandle : Boolean; dwProcessId : DWORD) : HANDLE;
external 'OpenProcess@kernel32.dll stdcall';

function CloseHandle(hObject : HANDLE) : BOOL;
external 'CloseHandle@kernel32.dll stdcall';


function EnumProcesses(var pProcessIds : PDWORD; cb : DWORD; var pBytesReturned : DWORD) : BOOL;
external 'EnumProcesses@psapi.dll stdcall';


function EnumProcessModules(hProcess : HANDLE; var lphModule : pHMODULE; cb : DWORD; var lpcbNeeded : LPDWORD) : BOOL;
external 'EnumProcessModules@psapi.dll stdcall';

function GetModuleFileNameExA(hProcess : HANDLE; hModule : HMODULE; lpFilename : LPTSTR; nSize : DWORD) : DWORD;
external 'GetModuleFileNameExA@psapi.dll stdcall';

function IsRunning(procName : String; fullPath : Boolean) : Boolean;
var
   found       : Boolean;
   filenameEnd : Integer;
   filename    : String;
   NA          : DWORD;
   entry       : DWORD;
   maxEntries  : DWORD;
   processes   : PDWORD;
   lpFilename  : LPTSTR;
   hProcess    : HANDLE;
   hMod        : pHMODULE;

begin

  SetLength(lpFilename, MAX_LENGTH);
  found := False;

  if (EnumProcesses(processes, SizeOf(processes), maxEntries)) then
  begin
    entry      := 0;
    maxEntries := maxEntries / SizeOf(maxEntries);

    while ((not found) and (entry < maxEntries)) do
    begin

      hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, False, processes[entry]);
      if (hProcess <> 0) then
      begin

      if (EnumProcessModules(hProcess, hMod, SizeOf(hMod), NA)) then
        if (GetModuleFileNameExA(hProcess, hMod[0], lpFilename, Length(lpFilename)) > 0) then
          begin
            filenameEnd := Pos(#0, lpFilename);
            filename := Copy(lpFilename, 1, filenameEnd - 1);

            if (not fullpath) then
              filename := ExtractFileName(filename);

            if (LowerCase(filename) = LowerCase(procName)) then
              found := True;
          end;

      CloseHandle(hProcess);
      end;

      entry := entry + 1;

    end;
  end;

  Result := found;
end;


function CheckForRunningModules(const messageId : TSetupMessageID) : Boolean;
var
   moduleRunning : Boolean;
   messageStr    : String;
   moduleName    : String;

begin
  Result     := True;
  moduleName := 'notepad.exe';
  messageStr := FmtMessage(SetupMessage(messageId), [moduleName]);

  Repeat
    moduleRunning := IsRunning(moduleName, False);

    if (moduleRunning) then
      if (MsgBox(messageStr, mbError, MB_OKCANCEL) = IDCANCEL) then
        Result := False;
  Until ((not moduleRunning) or (not Result));
end;

function InitializeSetup() : Boolean;
begin
   Result := CheckForRunningModules(msgSetupAppRunningError);
end;

function InitializeUninstall() : Boolean;
begin
   Result := CheckForRunningModules(msgUninstallAppRunningError);
end;
